/**
 * 
 * @author Christian Rempis
 * c.rempis@gmx.de
 * 
 */
package de.uos.ikw.octavio.spinalcordmanager.formatter;

public class Float8_8DataFormatter extends DataFormatter implements PlotDataSource {

	public Float8_8DataFormatter() {
		super("Float8/8", 2, "Interprets 2 byte to form a float.");
	}
	
	public DataFormatter createCopy() {
		Float8_8DataFormatter f = new Float8_8DataFormatter();
		f.setDescription(getDescription());
		return f;
	}
	
	public Object formatData(byte[] data, int offset) {
		if(offset + 1 >= data.length || offset < 0) {
			return null;
		}
		//TODO
		//return new Float((0xFF & (int) data[offset]));
		return new Float((float) ((int) ((0xFF & (int) data[offset + 1]) << 8 | (0xFF & (int) data[offset]))));
		//int val = ((0xFF & (int) data[offset + 1]) << 8 | (0xFF & (int) data[offset]));
		//int val = ((0xFF & (int) data[offset + 1]) << 8 | (0xFF & (int) data[offset]));
		//return new Float(Float.intBitsToFloat(val));
	}

	public double getAsDouble(byte[] data, int offset) {
		return (double) ((int) ((0xFF & (int) data[offset + 1]) << 8 | (0xFF & (int) data[offset])));
	}
	
	public Object formatIntIgnoringMapping(byte[] data, int offset) {
		if(offset + 1 >= data.length || offset < 0) {
			return new Integer(0);
		}
		return new Integer(((int) ((0xFF & (int) data[offset + 1]) << 8 
									| (0xFF & (int) data[offset]))));		
	}
	

}
