/**
 * 
 * @author Christian Rempis
 * c.rempis@gmx.de
 * 
 */
package de.uos.ikw.octavio.spinalcordmanager.formatter;

public class Int16DataFormatter extends DataFormatter implements PlotDataSource {

	public Int16DataFormatter() {
		super("Int16", 2, "Interprets 2 bytes to form an integer");
	}
	
	public DataFormatter createCopy() {
		Int16DataFormatter f = new Int16DataFormatter();
		f.setDescription(getDescription());
		return f;
	}
	
	public Object formatData(byte[] data, int offset) {
		if(offset + 1 >= data.length || offset < 0) {
			return null;
		}
		return new Integer((int) ((0xFF & (int) data[offset + 1]) << 8 | (0xFF & (int) data[offset])));
	}
	
	public double getAsDouble(byte[] data, int offset) {
		return (double) ((int) ((0xFF & (int) data[offset + 1]) << 8 | (0xFF & (int) data[offset])));
	}
	
	public Object formatIntIgnoringMapping(byte[] data, int offset) {
		if(offset + 1 >= data.length || offset < 0) {
			return new Integer(0);
		}
		return new Integer(((int) ((0xFF & (int) data[offset + 1]) << 8 
									| (0xFF & (int) data[offset]))));		
	}
	
}
