/**
 * 
 * @author Christian Rempis
 * c.rempis@gmx.de
 * 
 */
package de.uos.ikw.octavio.spinalcordmanager.formatter;

public class Int8DataFormatter extends DataFormatter implements PlotDataSource {

	public Int8DataFormatter() {
		super("Int8", 1, "Interprets 1 byte to form an integer");
	}
	
	public DataFormatter createCopy() {
		Int8DataFormatter f = new Int8DataFormatter();
		f.setDescription(getDescription());
		return f;
	}
	
	
	public Object formatData(byte[] data, int offset) {
		if(offset >= data.length || offset < 0) {
			return null;
		}
		return new Integer((int) (0xFF & (int) data[offset]));
	}

	public double getAsDouble(byte[] data, int offset) {
		return (double) ((int) (0xFF & (int) data[offset]));
	}

	public Object formatIntIgnoringMapping(byte[] data, int offset) {
		if(offset >= data.length || offset < 0) {
			return new Integer(0);
		}
		return new Integer((int) ((0xFF & (int) data[offset])));		
	}
	
}
