/**
 * 
 * @author Christian Rempis
 * c.rempis@gmx.de
 * 
 */
package de.uos.ikw.octavio.spinalcordmanager.formatter;

public class SyncDataFormatter extends DataFormatter {

	public SyncDataFormatter() {
		super("Sync", 1, "Returns a String with 'SYNC' if byte 0x55 was found.");
	}
	
	public DataFormatter createCopy() {
		SyncDataFormatter f = new SyncDataFormatter();
		f.setDescription(getDescription());
		return f;
	}
	
	public Object formatData(byte[] data, int offset) {
		if(offset >= data.length || offset < 0 || data[offset] != 0x55) {
			return null;
		}
		return "SYNC";
	}

}
