/**
 * 
 * @author Christian Rempis
 * c.rempis@gmx.de
 * 
 */
package de.uos.ikw.octavio.spinalcordmanager.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class FrameContainer {
	
	private JPanel mContent;
	private JFrame mFrame;
	private Action mTrigger;
	
	public FrameContainer(JPanel panel, String title, String triggerName, int width, int height) {
		mContent = panel;
		
		mFrame = new JFrame(title);
		mFrame.setSize(width, height);
		mFrame.getContentPane().setLayout(new BorderLayout());
		mFrame.getContentPane().add(mContent, BorderLayout.CENTER);
		
		
		mFrame.setVisible(false);
	
		mTrigger = new TriggerAction(triggerName);
		
	}
	
	public Action getTrigger() {
		return mTrigger;
	}
	
	public JFrame getFrame() {
		return mFrame;
	}
	
	public class TriggerAction extends AbstractAction {
		public static final long serialVersionUID = 923L;
		
		public TriggerAction(String name) {
			super(name);
		}
		
		public void actionPerformed(ActionEvent e) {
			mFrame.setVisible(true);
		}
	}

}
