package de.uos.ikw.octavio.spinalcordmanager.gui;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.JToggleButton;

import de.uos.ikw.octavio.spinalcordmanager.core.DataListener;
import de.uos.ikw.octavio.spinalcordmanager.core.DataManager;
import de.uos.ikw.octavio.spinalcordmanager.core.SpinalCordManager;
import de.uos.ikw.octavio.spinalcordmanager.formatter.DataFormatter;
//import de.uos.ikw.octavio.spinalcordmanager.formatter.PlotDataSource;
import de.uos.ikw.octavio.spinalcordmanager.io.Command;
import de.uos.ikw.octavio.spinalcordmanager.io.CommandWriter;

public class OscillationTestPanel extends GuiElement implements DataListener {

	private JLabel mMinLabel;
	private JLabel mMaxLabel;
	private JLabel mStrengthLabel;
	
	private JPanel mDisplay;
	private JTextField mMinMotor1;
	private JTextField mMaxMotor1;
	private JTextField mStrengthMotor1;
	private JButton mResetMotor1;
	/*
	private JTextField mMinMotor2;
	private JTextField mMaxMotor2;
	private JTextField mStrengthMotor2;
	private JButton mResetMotor2;
	
	private JTextField mMinMotor3;
	private JTextField mMaxMotor3;
	private JTextField mStrengthMotor3;
	private JButton mResetMotor3;
	*/
	private JToggleButton mStartStopButton;
	private JLabel mLegNumberLabel;
	private JSpinner mLegNumberSpinner;
	
	private boolean mMotor1Left;
	//private boolean mMotor2Left;
	//private boolean mMotor3Left;
	
	public OscillationTestPanel() {
		super("OscillationTestPanel");
		
		mDisplay = new JPanel(new BorderLayout());
		
		mMinLabel = new JLabel("MinAngle");
		mMaxLabel = new JLabel("MaxAngle");
		mStrengthLabel = new JLabel("Strength");
		mMinMotor1 = new JTextField("0");
		mMaxMotor1 = new JTextField("0");
		mStrengthMotor1 = new JTextField("100");
		mResetMotor1 = new JButton("Reset");
		
		mStartStopButton = new JToggleButton("Start");
		mStartStopButton.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				handleStartButton();
			}
			
		});
		
		mLegNumberLabel = new JLabel("Leg# ");
		mLegNumberSpinner = new JSpinner();
		
		JPanel motorPanel = new JPanel(new GridLayout(4, 2));
		motorPanel.add(mMinLabel);
		motorPanel.add(mMinMotor1);
		motorPanel.add(mMaxLabel);
		motorPanel.add(mMaxMotor1);
		motorPanel.add(mStrengthLabel);
		motorPanel.add(mStrengthMotor1);
		motorPanel.add(new JPanel());
		motorPanel.add(mResetMotor1);
		
		
		JPanel controlPanel = new JPanel(new GridLayout(4, 1));
		controlPanel.add(mStartStopButton);
		controlPanel.add(mLegNumberLabel);
		controlPanel.add(mLegNumberSpinner);
		
		mDisplay.add(BorderLayout.WEST, motorPanel);
		mDisplay.add(BorderLayout.EAST, controlPanel);
		
		
		if(!mMotor1Left) { //TODO remove, was only to avoid warning.
			mMotor1Left = false;
		}
		
		SpinalCordManager.getInstance().getDataManager().addDataListener(this);
	}
	
	public JPanel getDisplay() {
		return mDisplay;
	}

	public void dataContentChanged() {
		if(mStartStopButton.isSelected()) {
			DataManager dm = SpinalCordManager.getInstance().getDataManager();
			int legNumber = ((Integer) mLegNumberSpinner.getValue()).intValue();
			byte[] data = dm.getLastInterpretedDataFrame();
			DataFormatter formatters[] = dm.getDataFormatters();
			
			int index = dm.getMasterSectionSize() + dm.getSlot0SectionSize() 
					+ ((legNumber - 1) * dm.getSlotNSectionSize()) + 6;
			
			int numberOfBytes = 0;
			int i = 0;
			for(; i < formatters.length && numberOfBytes < index; ++i) {
				numberOfBytes += formatters[i].getNumberOfBytesPerData();
			}
			if(numberOfBytes < data.length - 1) {
				/*
				double sensor1 = ((PlotDataSource) formatters[i]).getAsDouble(data, index);
				double sensor2 = ((PlotDataSource) formatters[i + 1]).getAsDouble(data, index + formatters[i].getNumberOfBytesPerData());
				double sensor3 = ((PlotDataSource) formatters[i + 2]).getAsDouble(
						data, index + formatters[i].getNumberOfBytesPerData() + formatters[i + 1].getNumberOfBytesPerData());
				
				double min1 = 0.0;
				double max1 = 0.0;
				double min2 = 0.0;
				double max2 = 0.0;
				double min3 = 0.0;
				double max3 = 0.0;
				double strength1 = 0.0;
				double strength2 = 0.0;
				double strength3 = 0.0;
				
				try {
					min1 = Double.parseDouble(mMinMotor1.getText());
					max1 = Double.parseDouble(mMaxMotor1.getText());
					strength1 = Math.min(Math.max(0, Double.parseDouble(mStrengthMotor1.getText())), 255.0);
					
					min2 = Double.parseDouble(mMinMotor2.getText());
					max2 = Double.parseDouble(mMaxMotor2.getText());
					strength2 = Math.min(Math.max(0, Double.parseDouble(mStrengthMotor2.getText())), 255.0);
					
					min3 = Double.parseDouble(mMinMotor3.getText());
					max3 = Double.parseDouble(mMaxMotor3.getText());
					strength3 = Math.min(Math.max(0, Double.parseDouble(mStrengthMotor3.getText())), 255.0);
					
				} catch (NumberFormatException e) {
					sendStop();
					return;
				}
				
				if(mMotor1Left) {
					if(sensor1 <= min1) {
						mMotor1Left = false;
					}
					else {
						strength1 *= -1;
					}
				}
				else {
					if(sensor1 >= max1) {
						mMotor1Left = true;
						strength1 *= -1;
					}
				}
				System.out.println("Sending: " + legNumber + " sensor: " + sensor1 + " Min: " + min1 + " Max: " + max1);
				sendCommand(legNumber, strength1, 0.0, 0.0);
				*/
			}
		}
		else {
			//sendStop();
		}
	}

	public void dataHistoryChanged() {
		// TODO Auto-generated method stub
		
	}

	public void dataStructureChanged() {
		// TODO Auto-generated method stub
		
	}
	
	public void handleStartButton() {
		if(!mStartStopButton.isSelected()) {
			sendStop();
		}
	}
	
	public void sendStop() {
		CommandWriter writer = SpinalCordManager.getInstance().getCommandWriter();
		
		int command[] = new int[4];
		
		command[0] = Command.nextCommandId();
		command[1] = 255;
		command[2] = 0x60; //Leg Motor Stop Command
		command[3] = 0;

		//verify, do not discard
		writer.sendCommand(command, true, false, -1, false);
	}
	
	public void sendCommand(int legNumber, double motor1, double motor2, double motor3) {
		CommandWriter writer = SpinalCordManager.getInstance().getCommandWriter();
		
		int command[] = new int[10];
		
		
		command[0] = Command.nextCommandId();
		command[1] = legNumber;
		//command[2] = 208; //Leg Motor Command		
		command[2] = 0x70; //Leg Motor Command
		command[3] = 6;
		
		command[4] = motor1 > 0 ? 1 : 2;
		command[5] = (motor1 >= 0.0) ? (byte) Math.min(255, motor1) : (byte) Math.min(255, motor1 * -1);
		command[6] = 3;
		command[7] = 0;
		command[8] = 3;
		command[9] = 0;

		writer.sendCommand(command, false, true, -1, false);
	}
	
}

