package de.uos.ikw.octavio.spinalcordmanager.gui.byteObserver;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JToggleButton;

import de.uos.ikw.octavio.spinalcordmanager.core.SpinalCordManager;
import de.uos.ikw.octavio.spinalcordmanager.gui.GuiElement;
import de.uos.ikw.octavio.spinalcordmanager.io.RawByteListener;

public class ByteObserver extends GuiElement implements RawByteListener {

	private JPanel mDisplay;
	private JToggleButton mObserveButton;
	private JButton mClearButton;
	private JButton mUpdateButton;
	private JTextArea mByteArea;
	private int mPosition;
	private JScrollPane mScrollPane;
	private StringBuffer mByteBuffer;
	private ByteObserver mThis;
	
	public ByteObserver() {
		super("ByteObserver");
		
		mThis = this;
		
		mDisplay = new JPanel(new BorderLayout());
		
		mObserveButton = new JToggleButton("Start Byte Observing");
		mObserveButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(mObserveButton.isSelected()) {
					SpinalCordManager.getInstance().getDataReader().addRawByteListener(mThis);
				}
				else {
					SpinalCordManager.getInstance().getDataReader().removeRawByteListener(mThis);
				}
			}
		});
		
		mClearButton = new JButton("Clear Display");
		mClearButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				mByteBuffer = new StringBuffer();
				mByteArea.setText("");
				mPosition = 0;
			}
		});
		
		mUpdateButton = new JButton("Update View");
		mUpdateButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				mByteArea.setText(mByteBuffer.toString());
			}
		});
		
		JPanel headPanel = new JPanel(new BorderLayout());
		headPanel.add(BorderLayout.EAST, mObserveButton);
		headPanel.add(BorderLayout.CENTER, mUpdateButton);
		headPanel.add(BorderLayout.WEST, mClearButton);
		
		mDisplay.add(BorderLayout.NORTH, headPanel);
		
		mByteArea = new JTextArea();
		
		mScrollPane = new JScrollPane(mByteArea);
		mDisplay.add(BorderLayout.CENTER, mScrollPane);
		
		mObserveButton.setSelected(false);
		
		SpinalCordManager.getInstance().getDataReader().addRawByteListener(this);
		mPosition = 0;
		
		mByteBuffer = new StringBuffer();
	}
	
	public JPanel getDisplay() {
		return mDisplay;
	}

	public void byteReceived(byte receivedByte) {
		if(mObserveButton.isSelected()) {
			if(mByteBuffer.length() > 1000) {
				mByteBuffer = new StringBuffer();
				mPosition = 0;
			}
			if(mPosition >= 10) {
				mByteBuffer.append(Integer.toHexString(0xFF & (int) receivedByte)).append("\n");
				mPosition = -1;
			}
			else {
				mByteBuffer.append(Integer.toHexString(0xFF & (int) receivedByte)).append(",");
			}
			mPosition++;
		}
	}

	
	
	
	
}
