/**
 * 
 * @author Christian Rempis
 * c.rempis@gmx.de
 * 
 */
package de.uos.ikw.octavio.spinalcordmanager.gui.logpanel;

import java.awt.BorderLayout;
import java.awt.Point;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import de.uos.ikw.octavio.spinalcordmanager.core.SpinalCordManager;
import de.uos.ikw.octavio.spinalcordmanager.gui.GuiElement;
import de.uos.ikw.octavio.spinalcordmanager.io.ErrorStreamListener;

public class LogPanel extends GuiElement implements ErrorStreamListener {
	
	private JPanel mDisplay;
	private JTextArea mTextArea;
	private JScrollPane mScrollPane;

	public LogPanel() {
		super("LogPanel");
		
		mDisplay = new JPanel(new BorderLayout());
		
		mTextArea = new JTextArea();
		
		mScrollPane = new JScrollPane(mTextArea);
		mDisplay.add(mScrollPane, BorderLayout.CENTER);
		
		SpinalCordManager.getInstance().getErrorReader().addErrorStreamListener(this);
		
	}

	public JPanel getDisplay() {
		return mDisplay;
	}

	public void receivedErrorMessage(String errorMessage) {
		mTextArea.setText(mTextArea.getText() + "\n> " + errorMessage);
		mScrollPane.getViewport().setViewPosition(new Point(0, 100000));
	}

	public void receivedDataMessage(String messageHeader, byte[] data) {
		mTextArea.setText(mTextArea.getText() + "\n> DataMessage " + messageHeader + " (Size: " + data.length + ")");
		mScrollPane.getViewport().setViewPosition(new Point(0, 100000));
	}
	
}
