/**
 * 
 * @author Christian Rempis
 * c.rempis@gmx.de
 * 
 */
package de.uos.ikw.octavio.spinalcordmanager.gui.tableviewer;

import javax.swing.table.AbstractTableModel;

import de.uos.ikw.octavio.spinalcordmanager.core.DataListener;
import de.uos.ikw.octavio.spinalcordmanager.core.DataManager;
import de.uos.ikw.octavio.spinalcordmanager.core.SpinalCordManager;

public class SpinalCordDataModel extends AbstractTableModel implements DataListener {
	
	public static final long serialVersionUID = 543L;
	
	private int mColumns;
	private int mRows;
	private DataManager mDataManager;

	public SpinalCordDataModel() {
		mDataManager =  SpinalCordManager.getInstance().getDataManager();
		mDataManager.addDataListener(this);
		
		mColumns = mDataManager.getNumberOfColumns();
		mRows = mDataManager.getNumberOfRows();
	}
	
	public int getColumnCount() {
		return mColumns + 1;
	}
	
	public int getRowCount() {
		return mRows;
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		if(columnIndex == 0) {
			return new Integer(rowIndex);	
		}
		if(rowIndex >= mRows || columnIndex > mColumns) {
			return null;
		}
		return mDataManager.getCurrentData()[(columnIndex - 1) * mRows + rowIndex];
	}
	
	public String getColumnName(int columnIndex) {
		if(columnIndex == 0) {
			return "Index";	
		}
		if(columnIndex == 1) {
			return "Master";
		}
		return "Slot " + (columnIndex - 1);
	}
	
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		return false;
	}

	public void dataContentChanged() {
	}

	public void dataStructureChanged() {
		mDataManager = SpinalCordManager.getInstance().getDataManager();
		
		mColumns = mDataManager.getNumberOfColumns();
		mColumns = mDataManager.getNumberOfRows();
	}
	
	public void dataHistoryChanged() {
	}

}
