package de.uos.ikw.octavio.spinalcordmanager.gui.util;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JFrame;

import de.uos.ikw.octavio.spinalcordmanager.gui.FrameContainer;

public class ArrangeEEPROMFramesAction extends AbstractAction {

public static final long serialVersionUID = 893223L;
	
	private JFrame mMainFrame;
	private FrameContainer mPlotFrame;
	private FrameContainer mMappingFrame;
	private FrameContainer mRawByteObserverFrame;
	private FrameContainer mRawCommandFrame;
	private FrameContainer mDeploymentFrame;
	private boolean mActive;
	
	public ArrangeEEPROMFramesAction() {
		super("EEPROM Windows");
		mActive = false;
	}
	
	public void setMainFrame(JFrame frame) {
		mMainFrame = frame;
	}
	
	public void setPlotFrame(FrameContainer frame) {
		mPlotFrame = frame;
	}
	
	public void setMappingFrame(FrameContainer frame) {
		mMappingFrame = frame;
	}
	
	public void setRawByteObserverFrame(FrameContainer frame) {
		mRawByteObserverFrame = frame;
	}
	
	public void setRawCommandFrame(FrameContainer frame) {
		mRawCommandFrame = frame;
	}
	
	public void setDeploymentFrame(FrameContainer frame) {
		mDeploymentFrame = frame;
	}
	
	public void actionPerformed(ActionEvent arg0) {
		
		mActive = !mActive;
		
		if(mActive) {
			//Arranges the frmes of the plotter, the logger and the mapping controls.
			
			mRawCommandFrame.getFrame().setSize(mMainFrame.getWidth(), 100);
			mRawCommandFrame.getFrame().setLocation(mMainFrame.getX() + mMainFrame.getInsets().left, 
								mMainFrame.getY() + mMainFrame.getBounds().height + mMainFrame.getInsets().bottom);
			mRawCommandFrame.getFrame().setVisible(true);
			
			mPlotFrame.getFrame().setSize(mMainFrame.getWidth(), 200);
			mPlotFrame.getFrame().setLocation(mMainFrame.getX() + mMainFrame.getInsets().left, 
					mRawCommandFrame.getFrame().getY() + mRawCommandFrame.getFrame().getBounds().height 
					+ + mRawCommandFrame.getFrame().getInsets().bottom);
			mPlotFrame.getFrame().setVisible(true);
			
			mDeploymentFrame.getFrame().setSize(400, 500);
			mDeploymentFrame.getFrame().setLocation(mMainFrame.getX() + mMainFrame.getInsets().left + mMainFrame.getInsets().right + mMainFrame.getWidth(), mMainFrame.getY());
			mDeploymentFrame.getFrame().setVisible(true);
			
			mMappingFrame.getFrame().setSize(400, 200);
			mMappingFrame.getFrame().setLocation(mMainFrame.getX() + mMainFrame.getInsets().left + mMainFrame.getInsets().right + mMainFrame.getWidth(), 
												mMainFrame.getY()  + mDeploymentFrame.getFrame().getInsets().bottom + mDeploymentFrame.getFrame().getHeight());
			mMappingFrame.getFrame().setVisible(true);
			
			mRawByteObserverFrame.getFrame().setSize(400, 200);
			mRawByteObserverFrame.getFrame().setLocation(mMainFrame.getX() + mMainFrame.getInsets().left + mMainFrame.getInsets().right + mMainFrame.getWidth(), 
									mMainFrame.getY() + mDeploymentFrame.getFrame().getInsets().bottom + mDeploymentFrame.getFrame().getHeight()
									+ mMappingFrame.getFrame().getInsets().bottom + mMappingFrame.getFrame().getHeight());
			mRawByteObserverFrame.getFrame().setVisible(true);
			
			mMainFrame.setVisible(true);
			mMainFrame.toFront();
		}
		else {
			mRawCommandFrame.getFrame().setVisible(false);
			mPlotFrame.getFrame().setVisible(false);
			mDeploymentFrame.getFrame().setVisible(false);
			mMappingFrame.getFrame().setVisible(false);
			mRawByteObserverFrame.getFrame().setVisible(false);
		}
	}

}
