package de.uos.ikw.octavio.spinalcordmanager.gui.util;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JFrame;

import de.uos.ikw.octavio.spinalcordmanager.gui.FrameContainer;

public class ArrangeFramesAction extends AbstractAction {

	public static final long serialVersionUID = 893223L;
	
	private JFrame mMainFrame;
	private FrameContainer mPlotFrame;
	private FrameContainer mMappingFrame;
	private FrameContainer mLoggerFrame;
	private boolean mActive;
	
	public ArrangeFramesAction() {
		super("Sensor Windows");
		mActive = false;
	}
	
	public void setMainFrame(JFrame frame) {
		mMainFrame = frame;
	}
	
	public void setPlotFrame(FrameContainer frame) {
		mPlotFrame = frame;
	}
	
	public void setMappingFrame(FrameContainer frame) {
		mMappingFrame = frame;
	}
	
	public void setLoggerFrame(FrameContainer frame) {
		mLoggerFrame = frame;
	}
	
	
	public void actionPerformed(ActionEvent arg0) {
		
		mActive = !mActive;
		
		//Arranges the frmes of the plotter, the logger and the mapping controls.
		if(mActive) {
			mPlotFrame.getFrame().setSize(mMainFrame.getWidth(), 250);
			mPlotFrame.getFrame().setLocation(mMainFrame.getX() + mMainFrame.getInsets().left, mMainFrame.getY() + mMainFrame.getBounds().height  + mMainFrame.getInsets().bottom);
			mPlotFrame.getFrame().setVisible(true);
			
			mLoggerFrame.getFrame().setSize(400, Math.max(mMainFrame.getHeight() - 200, mMainFrame.getHeight() + mPlotFrame.getFrame().getHeight() - 200));
			mLoggerFrame.getFrame().setLocation(mMainFrame.getX() + mMainFrame.getInsets().left + mMainFrame.getInsets().right + mMainFrame.getWidth(), mMainFrame.getY());
			mLoggerFrame.getFrame().setVisible(true);
			
			mMappingFrame.getFrame().setSize(400, 200);
			mMappingFrame.getFrame().setLocation(mMainFrame.getX() + mMainFrame.getInsets().left + mMainFrame.getInsets().right + mMainFrame.getWidth(), 
												mMainFrame.getY() + mLoggerFrame.getFrame().getInsets().bottom + mLoggerFrame.getFrame().getHeight());
			mMappingFrame.getFrame().setVisible(true);
			
			mMainFrame.setVisible(true);
			mMainFrame.toFront();
		}
		else {
			mPlotFrame.getFrame().setVisible(false);
			mLoggerFrame.getFrame().setVisible(false);
			mMappingFrame.getFrame().setVisible(false);
		}
	}

}
