package de.uos.ikw.octavio.spinalcordmanager.gui.util;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JPanel;

import de.uos.ikw.octavio.spinalcordmanager.core.SpinalCordManager;
import de.uos.ikw.octavio.spinalcordmanager.gui.GuiElement;
import de.uos.ikw.octavio.spinalcordmanager.io.ErrorStreamListener;

public class AutoRepeatIndicator extends GuiElement implements
		ErrorStreamListener 
{

	private JPanel mDisplay;
	private boolean mAutoRepeatActive;
	
	public AutoRepeatIndicator() {
		super("AutoRepeatIndicator");
		mAutoRepeatActive = true;
		
		mDisplay = new JPanel() {

			public static final long serialVersionUID = 8723L;
			
			protected void paintComponent(Graphics g) {
				super.paintComponent(g);
				
				Graphics2D g2d = (Graphics2D) g;
				int size = Math.min(mDisplay.getWidth(), mDisplay.getHeight());
				Color old = g2d.getColor();
				if(mAutoRepeatActive) {
					g2d.setColor(Color.GREEN);
				}
				else {
					g2d.setColor(Color.RED);
				}
				g2d.fillOval(0, 0, size, size);
				g2d.setColor(old);
			}
			
		};
		
		SpinalCordManager.getInstance().getErrorReader().addErrorStreamListener(this);
	}
	
	
	
	public JPanel getDisplay() {
		return mDisplay;
	}

	public void receivedDataMessage(String messageHeader, byte[] data) {
	}

	public void receivedErrorMessage(String errorMessage) {
		if(errorMessage.startsWith("[R1]")) {
			mAutoRepeatActive = true;
			mDisplay.repaint();
		}
		else if(errorMessage.startsWith("[R0]")) {
			mAutoRepeatActive = false;
			mDisplay.repaint();
		}
	}

}
